/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.docs.insult.service.base;

import com.liferay.docs.insult.model.Insult;
import com.liferay.docs.insult.service.InsultLocalService;
import com.liferay.docs.insult.service.persistence.InsultPersistence;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.dao.orm.Projection;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.search.Indexable;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.model.PersistedModel;
import com.liferay.portal.service.BaseLocalServiceImpl;
import com.liferay.portal.service.PersistedModelLocalServiceRegistryUtil;
import com.liferay.portal.service.persistence.UserPersistence;

import java.io.Serializable;

import java.util.List;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the insult local service.
 *
 * <p>
 * This implementation exists only as a container for the default service
 * methods generated by ServiceBuilder. All custom service methods should be put
 * in {@link com.liferay.docs.insult.service.impl.InsultLocalServiceImpl}.
 * </p>
 *
 * @author joebloggs
 * @see com.liferay.docs.insult.service.impl.InsultLocalServiceImpl
 * @see com.liferay.docs.insult.service.InsultLocalServiceUtil
 * @generated
 */
public abstract class InsultLocalServiceBaseImpl extends BaseLocalServiceImpl implements InsultLocalService, IdentifiableBean {
	/*
	 * NOTE FOR DEVELOPERS:
	 * 
	 * Never modify or reference this class directly. Always use {@link
	 * com.liferay.docs.insult.service.InsultLocalServiceUtil} to access the
	 * insult local service.
	 */
	
	/**
	 * Adds the insult to the database. Also notifies the appropriate model
	 * listeners.
	 *
	 * @param insult
	 *            the insult
	 * @return the insult that was added
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	@Override
	public Insult addInsult(Insult insult) throws SystemException {
		insult.setNew(true);
		
		return insultPersistence.update(insult);
	}
	
	/**
	 * Creates a new insult with the primary key. Does not add the insult to the
	 * database.
	 *
	 * @param insultId
	 *            the primary key for the new insult
	 * @return the new insult
	 */
	@Override
	public Insult createInsult(long insultId) {
		return insultPersistence.create(insultId);
	}
	
	/**
	 * Deletes the insult with the primary key from the database. Also notifies
	 * the appropriate model listeners.
	 *
	 * @param insultId
	 *            the primary key of the insult
	 * @return the insult that was removed
	 * @throws PortalException
	 *             if a insult with the primary key could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	@Override
	public Insult deleteInsult(long insultId) throws PortalException, SystemException {
		return insultPersistence.remove(insultId);
	}
	
	/**
	 * Deletes the insult from the database. Also notifies the appropriate model
	 * listeners.
	 *
	 * @param insult
	 *            the insult
	 * @return the insult that was removed
	 * @throws PortalException
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	@Override
	public Insult deleteInsult(Insult insult) throws PortalException, SystemException {
		return insultPersistence.remove(insult);
	}
	
	@Override
	public DynamicQuery dynamicQuery() {
		Class<?> clazz = getClass();
		
		return DynamicQueryFactoryUtil.forClass(Insult.class, clazz.getClassLoader());
	}
	
	/**
	 * Performs a dynamic query on the database and returns the matching rows.
	 *
	 * @param dynamicQuery
	 *            the dynamic query
	 * @return the matching rows
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery) throws SystemException {
		return insultPersistence.findWithDynamicQuery(dynamicQuery);
	}
	
	/**
	 * Performs a dynamic query on the database and returns a range of the
	 * matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of
	 * <code>end - start</code> instances. <code>start</code> and
	 * <code>end</code> are not primary keys, they are indexes in the result
	 * set. Thus, <code>0</code> refers to the first result in the set. Setting
	 * both <code>start</code> and <code>end</code> to
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return
	 * the full result set. If <code>orderByComparator</code> is specified, then
	 * the query will include the given ORDER BY logic. If
	 * <code>orderByComparator</code> is absent and pagination is required (
	 * <code>start</code> and <code>end</code> are not
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the
	 * query will include the default ORDER BY logic from
	 * {@link com.liferay.docs.insult.model.impl.InsultModelImpl}. If both
	 * <code>orderByComparator</code> and pagination are absent, for performance
	 * reasons, the query will not have an ORDER BY clause and the returned
	 * result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param dynamicQuery
	 *            the dynamic query
	 * @param start
	 *            the lower bound of the range of model instances
	 * @param end
	 *            the upper bound of the range of model instances (not
	 *            inclusive)
	 * @return the range of matching rows
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end) throws SystemException {
		return insultPersistence.findWithDynamicQuery(dynamicQuery, start, end);
	}
	
	/**
	 * Performs a dynamic query on the database and returns an ordered range of
	 * the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of
	 * <code>end - start</code> instances. <code>start</code> and
	 * <code>end</code> are not primary keys, they are indexes in the result
	 * set. Thus, <code>0</code> refers to the first result in the set. Setting
	 * both <code>start</code> and <code>end</code> to
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return
	 * the full result set. If <code>orderByComparator</code> is specified, then
	 * the query will include the given ORDER BY logic. If
	 * <code>orderByComparator</code> is absent and pagination is required (
	 * <code>start</code> and <code>end</code> are not
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the
	 * query will include the default ORDER BY logic from
	 * {@link com.liferay.docs.insult.model.impl.InsultModelImpl}. If both
	 * <code>orderByComparator</code> and pagination are absent, for performance
	 * reasons, the query will not have an ORDER BY clause and the returned
	 * result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param dynamicQuery
	 *            the dynamic query
	 * @param start
	 *            the lower bound of the range of model instances
	 * @param end
	 *            the upper bound of the range of model instances (not
	 *            inclusive)
	 * @param orderByComparator
	 *            the comparator to order the results by (optionally
	 *            <code>null</code>)
	 * @return the ordered range of matching rows
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end, OrderByComparator orderByComparator) throws SystemException {
		return insultPersistence.findWithDynamicQuery(dynamicQuery, start, end, orderByComparator);
	}
	
	/**
	 * Returns the number of rows that match the dynamic query.
	 *
	 * @param dynamicQuery
	 *            the dynamic query
	 * @return the number of rows that match the dynamic query
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public long dynamicQueryCount(DynamicQuery dynamicQuery) throws SystemException {
		return insultPersistence.countWithDynamicQuery(dynamicQuery);
	}
	
	/**
	 * Returns the number of rows that match the dynamic query.
	 *
	 * @param dynamicQuery
	 *            the dynamic query
	 * @param projection
	 *            the projection to apply to the query
	 * @return the number of rows that match the dynamic query
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public long dynamicQueryCount(DynamicQuery dynamicQuery, Projection projection) throws SystemException {
		return insultPersistence.countWithDynamicQuery(dynamicQuery, projection);
	}
	
	@Override
	public Insult fetchInsult(long insultId) throws SystemException {
		return insultPersistence.fetchByPrimaryKey(insultId);
	}
	
	/**
	 * Returns the insult with the matching UUID and company.
	 *
	 * @param uuid
	 *            the insult's UUID
	 * @param companyId
	 *            the primary key of the company
	 * @return the matching insult, or <code>null</code> if a matching insult
	 *         could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public Insult fetchInsultByUuidAndCompanyId(String uuid, long companyId) throws SystemException {
		return insultPersistence.fetchByUuid_C_First(uuid, companyId, null);
	}
	
	/**
	 * Returns the insult matching the UUID and group.
	 *
	 * @param uuid
	 *            the insult's UUID
	 * @param groupId
	 *            the primary key of the group
	 * @return the matching insult, or <code>null</code> if a matching insult
	 *         could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public Insult fetchInsultByUuidAndGroupId(String uuid, long groupId) throws SystemException {
		return insultPersistence.fetchByUUID_G(uuid, groupId);
	}
	
	/**
	 * Returns the insult with the primary key.
	 *
	 * @param insultId
	 *            the primary key of the insult
	 * @return the insult
	 * @throws PortalException
	 *             if a insult with the primary key could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public Insult getInsult(long insultId) throws PortalException, SystemException {
		return insultPersistence.findByPrimaryKey(insultId);
	}
	
	@Override
	public PersistedModel getPersistedModel(Serializable primaryKeyObj) throws PortalException, SystemException {
		return insultPersistence.findByPrimaryKey(primaryKeyObj);
	}
	
	/**
	 * Returns the insult with the matching UUID and company.
	 *
	 * @param uuid
	 *            the insult's UUID
	 * @param companyId
	 *            the primary key of the company
	 * @return the matching insult
	 * @throws PortalException
	 *             if a matching insult could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public Insult getInsultByUuidAndCompanyId(String uuid, long companyId) throws PortalException, SystemException {
		return insultPersistence.findByUuid_C_First(uuid, companyId, null);
	}
	
	/**
	 * Returns the insult matching the UUID and group.
	 *
	 * @param uuid
	 *            the insult's UUID
	 * @param groupId
	 *            the primary key of the group
	 * @return the matching insult
	 * @throws PortalException
	 *             if a matching insult could not be found
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public Insult getInsultByUuidAndGroupId(String uuid, long groupId) throws PortalException, SystemException {
		return insultPersistence.findByUUID_G(uuid, groupId);
	}
	
	/**
	 * Returns a range of all the insults.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of
	 * <code>end - start</code> instances. <code>start</code> and
	 * <code>end</code> are not primary keys, they are indexes in the result
	 * set. Thus, <code>0</code> refers to the first result in the set. Setting
	 * both <code>start</code> and <code>end</code> to
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return
	 * the full result set. If <code>orderByComparator</code> is specified, then
	 * the query will include the given ORDER BY logic. If
	 * <code>orderByComparator</code> is absent and pagination is required (
	 * <code>start</code> and <code>end</code> are not
	 * {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the
	 * query will include the default ORDER BY logic from
	 * {@link com.liferay.docs.insult.model.impl.InsultModelImpl}. If both
	 * <code>orderByComparator</code> and pagination are absent, for performance
	 * reasons, the query will not have an ORDER BY clause and the returned
	 * result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start
	 *            the lower bound of the range of insults
	 * @param end
	 *            the upper bound of the range of insults (not inclusive)
	 * @return the range of insults
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public List<Insult> getInsults(int start, int end) throws SystemException {
		return insultPersistence.findAll(start, end);
	}
	
	/**
	 * Returns the number of insults.
	 *
	 * @return the number of insults
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public int getInsultsCount() throws SystemException {
		return insultPersistence.countAll();
	}
	
	/**
	 * Updates the insult in the database or adds it if it does not yet exist.
	 * Also notifies the appropriate model listeners.
	 *
	 * @param insult
	 *            the insult
	 * @return the insult that was updated
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	@Override
	public Insult updateInsult(Insult insult) throws SystemException {
		return insultPersistence.update(insult);
	}
	
	/**
	 * Returns the insult local service.
	 *
	 * @return the insult local service
	 */
	public com.liferay.docs.insult.service.InsultLocalService getInsultLocalService() {
		return insultLocalService;
	}
	
	/**
	 * Sets the insult local service.
	 *
	 * @param insultLocalService
	 *            the insult local service
	 */
	public void setInsultLocalService(com.liferay.docs.insult.service.InsultLocalService insultLocalService) {
		this.insultLocalService = insultLocalService;
	}
	
	/**
	 * Returns the insult persistence.
	 *
	 * @return the insult persistence
	 */
	public InsultPersistence getInsultPersistence() {
		return insultPersistence;
	}
	
	/**
	 * Sets the insult persistence.
	 *
	 * @param insultPersistence
	 *            the insult persistence
	 */
	public void setInsultPersistence(InsultPersistence insultPersistence) {
		this.insultPersistence = insultPersistence;
	}
	
	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public com.liferay.counter.service.CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}
	
	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService
	 *            the counter local service
	 */
	public void setCounterLocalService(com.liferay.counter.service.CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}
	
	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public com.liferay.portal.service.ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}
	
	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService
	 *            the resource local service
	 */
	public void setResourceLocalService(com.liferay.portal.service.ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}
	
	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public com.liferay.portal.service.UserLocalService getUserLocalService() {
		return userLocalService;
	}
	
	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService
	 *            the user local service
	 */
	public void setUserLocalService(com.liferay.portal.service.UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}
	
	/**
	 * Returns the user remote service.
	 *
	 * @return the user remote service
	 */
	public com.liferay.portal.service.UserService getUserService() {
		return userService;
	}
	
	/**
	 * Sets the user remote service.
	 *
	 * @param userService
	 *            the user remote service
	 */
	public void setUserService(com.liferay.portal.service.UserService userService) {
		this.userService = userService;
	}
	
	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}
	
	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence
	 *            the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}
	
	public void afterPropertiesSet() {
		Class<?> clazz = getClass();
		
		_classLoader = clazz.getClassLoader();
		
		PersistedModelLocalServiceRegistryUtil.register("com.liferay.docs.insult.model.Insult", insultLocalService);
	}
	
	public void destroy() {
		PersistedModelLocalServiceRegistryUtil.unregister("com.liferay.docs.insult.model.Insult");
	}
	
	/**
	 * Returns the Spring bean ID for this bean.
	 *
	 * @return the Spring bean ID for this bean
	 */
	@Override
	public String getBeanIdentifier() {
		return _beanIdentifier;
	}
	
	/**
	 * Sets the Spring bean ID for this bean.
	 *
	 * @param beanIdentifier
	 *            the Spring bean ID for this bean
	 */
	@Override
	public void setBeanIdentifier(String beanIdentifier) {
		_beanIdentifier = beanIdentifier;
	}
	
	@Override
	public Object invokeMethod(String name, String[] parameterTypes, Object[] arguments) throws Throwable {
		Thread currentThread = Thread.currentThread();
		
		ClassLoader contextClassLoader = currentThread.getContextClassLoader();
		
		if (contextClassLoader != _classLoader) {
			currentThread.setContextClassLoader(_classLoader);
		}
		
		try {
			return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
		} finally {
			if (contextClassLoader != _classLoader) {
				currentThread.setContextClassLoader(contextClassLoader);
			}
		}
	}
	
	protected Class<?> getModelClass() {
		return Insult.class;
	}
	
	protected String getModelClassName() {
		return Insult.class.getName();
	}
	
	/**
	 * Performs an SQL query.
	 *
	 * @param sql
	 *            the sql query
	 */
	protected void runSQL(String sql) throws SystemException {
		try {
			DataSource dataSource = insultPersistence.getDataSource();
			
			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource, sql, new int[0]);
			
			sqlUpdate.update();
		} catch (Exception e) {
			throw new SystemException(e);
		}
	}
	
	@BeanReference(type = com.liferay.docs.insult.service.InsultLocalService.class)
	protected com.liferay.docs.insult.service.InsultLocalService insultLocalService;
	@BeanReference(type = InsultPersistence.class)
	protected InsultPersistence insultPersistence;
	@BeanReference(type = com.liferay.counter.service.CounterLocalService.class)
	protected com.liferay.counter.service.CounterLocalService counterLocalService;
	@BeanReference(type = com.liferay.portal.service.ResourceLocalService.class)
	protected com.liferay.portal.service.ResourceLocalService resourceLocalService;
	@BeanReference(type = com.liferay.portal.service.UserLocalService.class)
	protected com.liferay.portal.service.UserLocalService userLocalService;
	@BeanReference(type = com.liferay.portal.service.UserService.class)
	protected com.liferay.portal.service.UserService userService;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private String _beanIdentifier;
	private ClassLoader _classLoader;
	private InsultLocalServiceClpInvoker _clpInvoker = new InsultLocalServiceClpInvoker();
}